routes/web.php
<?php

use App\Http\Controllers\AuthController;
use App\Http\Controllers\CastController;
use App\Http\Controllers\GenreController;
use App\Http\Controllers\FilmController;
use App\Http\Controllers\IndexController;
use App\Http\Controllers\KomentarController;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [IndexController::class, 'index']);
Route::get('/register', [AuthController::class, 'register']);
Route::post('/welcome', [AuthController::class, 'welcome']);

Route::middleware(['auth'])->group(function(){

    Route::get('/data-table', [IndexController::class, 'datatable']);

});
// Route::get('/master', function(){

//     return view('layout.master');
// });
// Route::get('/', function () {
//     return view('welcome');
// });


Route::resource('cast', CastController::class);
Route::resource('film', FilmController::class);
Route::resource('genre', GenreController::class);
Route::resource('film', FilmController::class);

Route::middleware(['auth'])->group(function(){
    Route::get('cast/delete/{id}', [CastController::class, 'delete'])->name('delete');
    Route::get('genre/delete/{id}', [GenreController::class, 'delete'])->name('genre.delete');
    Route::get('film/delete/{id}', [FilmController::class, 'delete'])->name('film.delete');
    Route::post('komentar', [KomentarController::class, 'store']);
});

Auth::routes();

// Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/Film.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Film extends Model
{
    use HasFactory;

    protected $fillable = ['judul', 'ringkasan', 'tahun', 'poster', 'genre_id'];

    public function genre(){
        
        return $this->belongsTo(Genre::class, 'genre_id');
    }

    public function komentar()
    {
        return $this->hasMany(Komentar::class, 'film_id');
    }
}

app/Http/Controllers/FilmController.php
<?php

namespace App\Http\Controllers;

use App\Models\Film;
use App\Models\Genre;
use Illuminate\Http\Request;
use File;

class FilmController extends Controller
{

    public function __construct()
    {
        $this->middleware('auth')->except('index', 'show');
    }    
    
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $films = Film::all();
        return view('pages.film.index', ['films' => $films]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {

        $genres = Genre::all();
        return view('pages.film.create', compact('genres'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'judul' => 'required',
            'ringkasan' => 'required',
            'year' => ['required', 'numeric'],
            'poster' => ['required', 'image', 'mimes:jpg,png,jpeg', 'max:2048'],
            'genre_id' => ['required', 'numeric']
        ]);

        $filename = time().'.'. $request->poster->extension();

        $request->poster->move(public_path('images'), $filename);

        // Film::create($request->all());
        $film = new Film;
        $film->judul = $request->judul;
        $film->ringkasan = $request->ringkasan;
        $film->year = $request->year;
        $film->genre_id = $request->genre_id;
        $film->poster = $filename;

        $film->save();


        return redirect('film')->with('success', 'Film berhasil ditambahkan!');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $film = Film::find($id);
        return view('pages.film.detail', compact('film'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $film = Film::find($id);
        $genres = Genre::all();

        return view('pages.film.edit', compact('film', 'genres'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $this->validate($request, [
            'judul' => 'required',
            'ringkasan' => 'required',
            'year' => ['required', 'numeric'],
            'genre_id' => ['required', 'numeric'],                                    
            'poster' => ['image', 'mimes:jpg,png,jpeg', 'max:2048'],                         //upload file misalnya tidak required
        ]);

        $film = Film::find($id);
        if($request->has('poster')){
            $path = 'images/';

            File::delete($path . $film->poster);

            $filename = time().'.'. $request->poster->extension();
            $request->poster->move(public_path('images'), $filename);
            $film->poster = $filename;
        }

        $film->judul = $request->judul;
        $film->ringkasan = $request->ringkasan;
        $film->year = $request->year;
        $film->genre_id = $request->genre_id;

        $film->update();

        return redirect('film')->with('success', 'Film berhasil diupdate!');

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $film = Film::find($id);
        $film->delete();
        return redirect('film')->with('success', 'Film berhasil dihapus!');
    }

    public function delete($id){
        
        $film = Film::find($id);

        return view('pages.film.delete', compact('film'));
    }
}

resources/views/pages/film/create.blade.php
@extends('layout.master')

@section('content')

    <div class="card">
        <div class="card-header">
            <h3 class="card-title">Tambah Film</h3>
        </div>
        <div class="card-body">
            <form action="/film" method="post" enctype="multipart/form-data">
                @csrf
                <div class="form-group">
                    <label>Judul</label>
                    <input type="text" name="judul" id="judul" value="{{old('judul')}}" class="form-control form-control-sm">
                    @error('judul')
                        <div class="alert alert-danger">
                            {{$message}}
                        </div>
                    @enderror
                </div>
                <div class="form-group">
                    <label>Year</label>
                    <input type="text" name="year" id="year" value="{{old('year')}}" class="form-control form-control-sm">
                    @error('year')
                        <div class="alert alert-danger">
                            {{$message}}
                        </div>
                    @enderror
                </div>
                <div class="form-group">
                    <label>Ringkasan</label>
                    <textarea name="ringkasan" id="ringkasan" cols="30" rows="10" class="form-control form-control-sm">{{old('ringkasan')}} </textarea>
                    @error('ringkasan')
                        <div class="alert alert-danger">
                            {{$message}}
                        </div>
                    @enderror
                </div>
                <div class="form-group">
                    <label>Genre</label>
                    <select name="genre_id" id="genre_id" class="form-control form-control-sm">
                        <option value="">--Pilih Genre--</option>
                        @forelse ($genres as $item)
                            <option value="{{$item->id}}" {{$item->id==old('genre_id')?'selected':''}}>{{$item->nama}} </option>
                        @empty
                            <option value="">Tidak ada data</option>
                        @endforelse
                    </select>
                    @error('genre_id')
                        <div class="alert alert-danger">
                            {{$message}}
                        </div>
                    @enderror
                </div>
                <div class="form-group">
                    <label>Poster</label>
                    <input type="file" name="poster" id="poster" value="{{old('poster')}}" class="form-control form-control-sm">
                    @error('poster')
                        <div class="alert alert-danger">
                            {{$message}}
                        </div>
                    @enderror
                </div>
                <button type="submit" class="btn btn-sm btn-primary">Simpan</button>
            </form>
        </div>
    </div>
    
@endsection

resources/views/pages/film/delete.blade.php
{{-- !-- Delete Body -->  --}}
<form action="{{ route('film.destroy', $film->id) }}" method="post">
    <div class="modal-body">
        @csrf
        @method('DELETE')
        <h5 class="text-center">Anda yakin menghapus {{ $film->judul }} ini?</h5>
    </div>
    <div class="modal-footer">
        <button type="button" class="btn btn-sm btn-secondary" data-dismiss="modal">Tidak</button>
        <button type="submit" class="btn btn-sm btn-danger">Ya, Hapus</button>
    </div>
</form>

resources/views/pages/film/detail.blade.php
@extends('layout.master')

@section('content')

<div class="card">
    <div class="card-header">
        <h3>Detail Film</h3>        
    </div>
    <div class="card-body">
        <div class="row">
            {{-- <div class="col-sm-12">Poster</div> --}}
            <div class="col-sm-12 mb-3">
                <img src="{{asset('images/'.$film->poster)}}" alt="" width="60%">
            </div>
        </div>
        <div class="row">
            <div class="col-sm-2">Nama</div>
            <div class="col-sm-9">: {{$film->judul}} </div>
        </div>
        <div class="row">
            <div class="col-sm-2">Umur</div>
            <div class="col-sm-9">: {{$film->year}} </div>
        </div>
        <div class="row">
            <div class="col-sm-2">Genre</div>
            <div class="col-sm-9">: {{$film->genre->nama}} </div>
        </div>
        <div class="row">
            <div class="col-sm-2">Bio</div>
            <div class="col-sm-9">: {{$film->ringkasan}} </div>
        </div><hr>

        <div class="row">
            <div class="col-sm-12">
                <h2>Komentar:</h2>
                @forelse ($film->komentar as $item)
                <div class="media border my-2">
                    <h1 class="mr-3 ml-2 my-1">{{$item->point}}</h1>
                    <div class="media-body">
                      <h5 class="mt-1 text-info">{{$item->user->name}}</h5>
                      <p>{{$item->content}}</p>
                    </div>
                </div>
                    
                @empty
                    <p>Tidak ada komentar</p>
                @endforelse
                <form action="/komentar" method="post" class="my-5">
                    @csrf
                    <input type="hidden" name="film_id" value="{{$film->id}}">
                    <div class="form-group">
                        <select name="point" id="point" class="form-control form-control-sm">
                            <option value="">--Pilih Point--</option>
                            <option value="1">1</option>
                            <option value="2">2</option>
                            <option value="3">3</option>
                            <option value="4">4</option>
                            <option value="5">5</option>
                        </select>
                    </div>
                    @error('point')
                    <div class="alert alert-danger">
                        {{$message}}
                    </div>
                    @enderror
                    <div class="form-group">
                        <textarea name="content" id="" cols="30" rows="5" class="form-control form-control-sm">{{old('content')}} </textarea>
                    </div>
                    @error('content')
                    <div class="alert alert-danger">
                        {{$message}}
                    </div>
                    @enderror
                    <button type="submit" class="btn btn-sm btn-primary">Kirim Komentar</button>
                </form>
            </div>
        </div>
        <a href="/film" class="btn btn-sm btn-block btn-secondary my-5"> Kembali</a>
    </div>
</div>
    
@endsection

resources/views/pages/film/edit.blade.php
@extends('layout.master')

@section('content')

    <div class="card">
        <div class="card-header">
            <h3 class="card-title">Edit Film</h3>
        </div>
        <div class="card-body">
            <form action="/film/{{$film->id}}" method="post" enctype="multipart/form-data">
                @csrf
                @method('PUT')
                <div class="form-group">
                    <label>Judul</label>
                    <input type="text" name="judul" id="judul" value="{{$film->judul}}" class="form-control form-control-sm">
                    @error('judul')
                        <div class="alert alert-danger">
                            {{$message}}
                        </div>
                    @enderror
                </div>
                <div class="form-group">
                    <label>Year</label>
                    <input type="text" name="year" id="year" value="{{$film->year}}" class="form-control form-control-sm">
                    @error('year')
                        <div class="alert alert-danger">
                            {{$message}}
                        </div>
                    @enderror
                </div>
                <div class="form-group">
                    <label>Ringkasan</label>
                    <textarea name="ringkasan" id="ringkasan" cols="30" rows="10" class="form-control form-control-sm">{{$film->ringkasan}}</textarea>
                    @error('ringkasan')
                        <div class="alert alert-danger">
                            {{$message}}
                        </div>
                    @enderror
                </div>
                <div class="form-group">
                    <label>Genre</label>
                    <select name="genre_id" id="genre_id" class="form-control form-control-sm">
                        @forelse ($genres as $item)
                            <option value="">--Pilih Genre--</option>
                            <option value="{{$item->id}}" {{$item->id==$film->genre_id?'selected':''}} >{{$item->nama}} </option>
                        @empty
                            <option value="">Tidak ada data</option>
                        @endforelse
                    </select>
                    @error('genre_id')
                        <div class="alert alert-danger">
                            {{$message}}
                        </div>
                    @enderror
                </div>
                <div class="form-group">
                    <label>Poster</label>
                    <input type="file" name="poster" id="poster" class="form-control form-control-sm">
                    @error('poster')
                        <div class="alert alert-danger">
                            {{$message}}
                        </div>
                    @enderror
                </div>
                <button type="submit" class="btn btn-sm btn-primary">Simpan</button>
            </form>
        </div>
    </div>
    
@endsection

resources/views/pages/film/index.blade.php
@extends('layout.master')

@section('content')

@if (session('success'))
    <div class="alert alert-success">
        {{ session('success') }}
    </div>
@endif

    <div class="card">
        <div class="card-header">
            <h3 class="card-title">List Film</h3>
        </div>
        <div class="card-body">
            <div class="row">
                @forelse ($films as $item)

                    <div class="col-sm-4">
                        <div class="card" style="width: 18rem;">
                            <img src="/images/{{$item->poster}}" class="card-img-top" alt="">
                            <div class="card-body">
                              <h5 class="card-title text-info">{{$item->judul}} </h5> <br> 
                              <span class="badge badge-pill badge-dark">{{$item->genre->nama}} </span>
                              <span class="badge badge-pill badge-dark">{{$item->year}} </span>
                              <hr>
                              <p class="card-text">{{Str::limit($item->ringkasan, 20)}} </p>
                              <div class="row my-2">
                                @guest
                                <a href="/film/{{$item->id}}" class="btn btn-sm btn-primary btn-block mx-1"> Detail</a>
                                @endguest
                                @auth
                                <a href="/film/{{$item->id}}" class="btn btn-sm btn-primary mx-1"> Detail</a>
                                <a href="/film/{{$item->id}}/edit" class="btn btn-sm btn-warning mx-1">Edit</a>
                                <a class="btn btn-sm btn-danger" data-toggle="modal" id="buttonDelete" data-target="#deleteModal" data-attr="{{ route('film.delete', $item->id) }}" title="Delete Cast">
                                    Delete
                                </a>
                                @endauth
                              </div>
                            </div>
                        </div>
        
                    </div>
                    
                    
                    @empty
                    Tidak ada list film
                    @endforelse
                </div>
        </div>
    </div>

    <!-- delete modal -->
    <div class="modal fade" id="deleteModal" tabindex="-1" role="dialog" aria-labelledby="smallModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-sm" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body" id="deleteBody">
                    <div>
                        {{-- MODAL FORM DELETE --}}
                    </div>
                </div>
            </div>
        </div>
    </div>
    
@endsection

@push('script')

<script>
    
    $(document).on('click', '#buttonDelete', function(event) {
        event.preventDefault();
        let href = $(this).attr('data-attr');
        console.log(href)
        $.ajax({
            url: href, 
            success: function(result) {
                $('#deleteModal').modal("show");
                $('#deleteBody').html(result).show();
            }, 
            // complete: function() {
            //     $('#loader').hide();
            // }, 
            error: function(jqXHR, testStatus, error) {
                console.log(error);
                alert("Page " + href + " cannot open. Error:" + error);
                $('#loader').hide();
            }, 
            timeout: 8000
        })
    });

</script>
    
@endpush